﻿using System;
using System.Drawing;
using System.IO;
using System.Windows.Forms;
using IDAutomation.NetStandard.PDF417.FontEncoder;
namespace Test_GUI
{
    public partial class FullTest : Form
    {
        public FullTest()
        {
            InitializeComponent();
            cmbOutput.SelectedIndex = 1;
            cbEncoding.SelectedIndex = 0;
            cbECCLevel.SelectedIndex = 0;
            txtModuleSize.Text = "2";
            txtQuietZone.Text = "2";
            txtRows.Text = "0";
            txtCols.Text = "0";

            frmDemo frm2 = new frmDemo();
            frm2.ShowDialog();

        }

        private void Form1_Load(object sender, EventArgs e)
        {
        }

        private void btUpdate_Click_1(object sender, EventArgs e)
        {


            string dataToEncode = tbDatatoencode.Text;
            bool applyTilde = ckApplyTilde.Checked;
            bool truncate = ckTruncate.Checked;
            int ModuleSize = int.Parse(txtModuleSize.Text);
            int QuietZone = int.Parse(txtQuietZone.Text);
            int TotalRows = int.Parse(txtRows.Text);
            int TotalCols = int.Parse(txtCols.Text);
            int ECLevel = cbECCLevel.SelectedIndex;


            if (TotalRows > 89) {
                TotalRows = 89;
                txtRows.Text = "89";
            }

            if (TotalCols > 30)
            {
                TotalCols = 30;
                txtCols.Text = "30";
            }

            EncodingModes encodingMode = EncodingModes.Binary;
            switch (cbEncoding.SelectedIndex)
            {
                case 1:
                    encodingMode = EncodingModes.Text;
                    break;
            }

            PDF417 PDF417 = new PDF417();
            byte[] raster = null;
            String vector = "";
            String encodedText = "";

            OutputTypes outType = OutputTypes.IDA2DFont;
            if (cmbOutput.SelectedIndex == 2) outType = OutputTypes.IDAMonospaceFont;


            webCode.Visible = false;
            picCode.Visible = false;
            lblCode.Visible = false;

            if (cmbOutput.SelectedIndex == 3) // BMP raster image output
            {
                raster = PDF417.EncodePDF417(dataToEncode , applyTilde,ECLevel, encodingMode, TotalCols, TotalRows, truncate, QuietZone, ModuleSize);
                picCode.AutoSize = true;
                using (MemoryStream mStream = new MemoryStream(raster))
                {
                    Image img1 = Image.FromStream(mStream);
                    picCode.Image = img1;


                    // // code to produce a PNG or a GIF or other formats
                    // // **************************************************
                    //MemoryStream mStream1 = new MemoryStream(raster);
                    //Image img1 = Image.FromStream(mStream1);

                    //MemoryStream mStream2 = new MemoryStream();
                    //if ( __PNG__ ) // PNG
                    //    img1.Save(mStream2, ImageFormat.Png);
                    //else if ( __GIF__ ) // GIF
                    //    img1.Save(mStream2, ImageFormat.Gif);

                    //raster = mStream2.ToArray();
                    // // **************************************************


                }
                picCode.Visible = true;

                if (chkSaveGraphic.Checked)
                  File.WriteAllBytes("PDF417.BMP", raster);

            }
            else if (cmbOutput.SelectedIndex == 4)
            {

                vector = PDF417.EncodePDF417(dataToEncode , applyTilde,ECLevel, encodingMode, TotalCols, TotalRows, truncate,  VectorTypes.VecSVG, null, QuietZone, ModuleSize);
                webCode.DocumentText = vector;
                webCode.Visible = true;
                if (chkSaveGraphic.Checked)
                    File.WriteAllText("PDF417.SVG", vector);

            }
            else if (cmbOutput.SelectedIndex == 5)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ECLevel, encodingMode, TotalCols, TotalRows, truncate,  VectorTypes.VecHTML, null, QuietZone, ModuleSize);
                webCode.DocumentText = vector;
                webCode.Visible = true;
                if (chkSaveGraphic.Checked)
                    File.WriteAllText("PDF417.HTML", vector);
            }
            else if (cmbOutput.SelectedIndex == 6)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ECLevel, encodingMode, TotalCols, TotalRows, truncate, VectorTypes.VecEPS, null, QuietZone, ModuleSize);
                if (chkSaveGraphic.Checked)
                    File.WriteAllText("PDF417.EPS", vector);
            }
            else
            {
                encodedText = PDF417.EncodePDF417(dataToEncode,  applyTilde, ECLevel, encodingMode, TotalCols, TotalRows, truncate, outType);
                if (cmbOutput.SelectedIndex == 2)
                {
                    lblCode.Font = new System.Drawing.Font("Courier New", 6F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                }
                else if (cmbOutput.SelectedIndex == 1)
                {
                    lblCode.Font = new System.Drawing.Font("IDAutomation2D", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                }
                else if (cmbOutput.SelectedIndex == 0)
                {
                    lblCode.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                }

                lblCode.Text = encodedText;
                lblCode.Visible = true;
            }
        }

        private void cmbOutput_SelectedIndexChanged(object sender, EventArgs e)
        {
            txtQuietZone.Enabled = (cmbOutput.SelectedIndex >= 3);
            txtModuleSize.Enabled = (cmbOutput.SelectedIndex >= 3);
            chkSaveGraphic.Enabled = (cmbOutput.SelectedIndex >= 3);
        }

        private void button1_Click(object sender, EventArgs e)
        {

            TabTest frm2 = new TabTest();
            frm2.ShowDialog();
        }

        private void cbFormat_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
    }


}

