﻿using System;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Windows.Forms;
using IDAutomation.NetStandard.PDF417.FontEncoder;


namespace Test_GUI
{
    public partial class TabTest : Form
    {
        public TabTest()
        {
            InitializeComponent();

            cmbMode.SelectedIndex = 0;
//            inputTests(); //run starter function
        }


        public void inputTests()
        {

            PDF417 PDF417 = new PDF417();
            int counter = 1;
            string encodedText = "";
            int PDFCols = 0;
            int PDFRows = 0;
            bool truncate = false;

            string dataToEncode = "123456789012";
            bool applyTilde = false;        // use ~ for special encoding
            EncodingModes encodingMode = EncodingModes.Binary;
            int ecLevel = 0;

            OutputTypes outType = OutputTypes.IDA2DFont;
            if (cmbMode.SelectedIndex == 1) outType = OutputTypes.IDAMonospaceFont;
            byte[] raster = null;
            String vector = "";

            //****************************************************************************************************************************************************
            dataToEncode = "IDAutomation.com 123456789012~m10";
            applyTilde = true;
            ecLevel = 0;
            encodingMode = EncodingModes.Text;
            PDFCols = 4;
            PDFRows = 0;
            truncate = false;
            if (cmbMode.SelectedIndex == 2) // BMP raster image output
            {
                raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3);
                File.WriteAllBytes("PDF417" + counter.ToString() + ".BMP", raster);


            }
            else if (cmbMode.SelectedIndex == 3)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, null, 2, 2);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".SVG", vector);
            }
            else if (cmbMode.SelectedIndex == 4)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, null, 2, 1);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".HTML", vector);
            }
            else
            {
                encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType);
            }
            renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector);

            if (chkSaveEPS.Checked)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecEPS, null, 2, 2);
                File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector);

            }
            counter++;

            //****************************************************************************************************************************************************
            dataToEncode = "ID AutoMation.com~0091234567890123456(!@#$1234$^&*9999~`<>)";
            applyTilde = true;
            ecLevel = 3;
            encodingMode = EncodingModes.Binary;
            PDFCols = 4;
            PDFRows = 0;
            truncate = false;
            if (cmbMode.SelectedIndex == 2) // BMP raster image output
            {
                raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3);
                File.WriteAllBytes("PDF417" + counter.ToString() + ".BMP", raster);


            }
            else if (cmbMode.SelectedIndex == 3)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, null, 2, 2);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".SVG", vector);
            }
            else if (cmbMode.SelectedIndex == 4)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, null, 2, 1);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".HTML", vector);
            }
            else
            {
                encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType);
            }
            renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector);

            if (chkSaveEPS.Checked)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecEPS, null, 2, 2);
                File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector);

            }
            counter++;

            //****************************************************************************************************************************************************
            dataToEncode = "ID AutoMation.com~0091234567890123456(!@#$1234$^&*9999~`<>)";
            applyTilde = true;
            ecLevel = 3;
            encodingMode = EncodingModes.Binary;
            PDFCols = 4;
            PDFRows = 0;
            truncate = true;
            if (cmbMode.SelectedIndex == 2) // BMP raster image output
            {
                raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3);
                File.WriteAllBytes("PDF417" + counter.ToString() + ".BMP", raster);


            }
            else if (cmbMode.SelectedIndex == 3)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, null, 2, 2);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".SVG", vector);
            }
            else if (cmbMode.SelectedIndex == 4)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, null, 2, 1);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".HTML", vector);
            }
            else
            {
                encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType);
            }
            renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector);

            if (chkSaveEPS.Checked)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecEPS, null, 2, 2);
                File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector);

            }
            counter++;


            //****************************************************************************************************************************************************
            dataToEncode = "Error Correction Level 1 Test [010491234512345IDAUTOMATION915970331301289999]";
            applyTilde = true;
            ecLevel = 1;
            encodingMode = EncodingModes.Text;
            PDFCols = 3;
            PDFRows = 0;
            truncate = false;
            if (cmbMode.SelectedIndex == 2) // BMP raster image output
            {
                raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3);
                File.WriteAllBytes("PDF417" + counter.ToString() + ".BMP", raster);


            }
            else if (cmbMode.SelectedIndex == 3)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, null, 2, 2);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".SVG", vector);
            }
            else if (cmbMode.SelectedIndex == 4)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, null, 2, 1);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".HTML", vector);
            }
            else
            {
                encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType);
            }
            renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector);

            if (chkSaveEPS.Checked)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecEPS, null, 2, 2);

            }
            counter++;



            //****************************************************************************************************************************************************
            dataToEncode = "Error Correction Level 2 Test [010491234512345IDAUTOMATION915970331301289999]";
            applyTilde = true;
            ecLevel = 2;
            encodingMode = EncodingModes.Text;
            PDFCols = 5;
            PDFRows = 0;
            truncate = false;
            if (cmbMode.SelectedIndex == 2) // BMP raster image output
            {
                raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3);
                File.WriteAllBytes("PDF417" + counter.ToString() + ".BMP", raster);


            }
            else if (cmbMode.SelectedIndex == 3)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, null, 2, 2);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".SVG", vector);
            }
            else if (cmbMode.SelectedIndex == 4)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, null, 2, 1);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".HTML", vector);
            }
            else
            {
                encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType);
            }
            renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector);

            if (chkSaveEPS.Checked)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecEPS, null, 2, 2);
                File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector);

            }
            counter++;



            //****************************************************************************************************************************************************
            dataToEncode = "Error Correction Level 3 Test [010491234512345IDAUTOMATION915970331301289999]";
            applyTilde = true;
            ecLevel = 3;
            encodingMode = EncodingModes.Text;
            PDFCols = 6;
            PDFRows = 0;
            truncate = false;
            if (cmbMode.SelectedIndex == 2) // BMP raster image output
            {
                raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3);
                File.WriteAllBytes("PDF417" + counter.ToString() + ".BMP", raster);


            }
            else if (cmbMode.SelectedIndex == 3)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, null, 2, 2);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".SVG", vector);
            }
            else if (cmbMode.SelectedIndex == 4)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, null, 2, 1);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".HTML", vector);
            }
            else
            {
                encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType);
            }
            renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector);

            if (chkSaveEPS.Checked)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecEPS, null, 2, 2);
                File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector);

            }
            counter++;



            //****************************************************************************************************************************************************
            dataToEncode = "2D~~Matrix~ Tilde Test of popular codes: |~000|~001|~004|~009|~010|~013|~028|~029|~030|~031|~255| &lt;~END~d6u8~end&gt;";
            applyTilde = true;
            ecLevel = 0;
            encodingMode = EncodingModes.Binary;
            PDFCols = 0;
            PDFRows = 0;
            truncate = false;
            if (cmbMode.SelectedIndex == 2) // BMP raster image output
            {
                raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3);
                File.WriteAllBytes("PDF417" + counter.ToString() + ".BMP", raster);


            }
            else if (cmbMode.SelectedIndex == 3)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, null, 2, 2);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".SVG", vector);
            }
            else if (cmbMode.SelectedIndex == 4)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, null, 2, 1);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".HTML", vector);
            }
            else
            {
                encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType);
            }
            renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector);

            if (chkSaveEPS.Checked)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecEPS, null, 2, 2);
                File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector);

            }
            counter++;



            //****************************************************************************************************************************************************
            dataToEncode = "256 Characters with Tilde Commands: (500 chrs total) |~000|~001|~002|~003|~004|~005|~006|~007|~008|~009|~010|~011|~012|~013|~014|~015|~016|~017|~018|~019|~020|~021|~022|~023|~024|~025|~026|~027|~028|~029|~030|~031|~032|~033|~034|~035|~036|~037|~038|~039|~040|~041|~042|~043|~044|~045|~046|~047|~048|~049|~050|~051|~052|~053|~054|~055|~056|~057|~058|~059|~060|~061|~062|~063|~064|~065|~066|~067|~068|~069|~070|~071|~072|~073|~074|~075|~076|~077|~078|~079|~080|~081|~082|~083|~084|~085|~086|~087|~088|~089|~090|~091|~092|~093|~094|~095|~096|~097|~098|~099|~100|~101|~102|~103|~104|~105|~106|~107|~108|~109|~110|~111|~112|~113|~114|~115|~116|~117|~118|~119|~120|~121|~122|~123|~124|~125|~126|~127|~128|~129|~130|~131|~132|~133|~134|~135|~136|~137|~138|~139|~140|~141|~142|~143|~144|~145|~146|~147|~148|~149|~150|~151|~152|~153|~154|~155|~156|~157|~158|~159|~160|~161|~162|~163|~164|~165|~166|~167|~168|~169|~170|~171|~172|~173|~174|~175|~176|~177|~178|~179|~180|~181|~182|~183|~184|~185|~186|~187|~188|~189|~190|~191|~192|~193|~194|~195|~196|~197|~198|~199|~200|~201|~202|~203|~204|~205|~206|~207|~208|~209|~210|~211|~212|~213|~214|~215|~216|~217|~218|~219|~220|~221|~222|~223|~224|~225|~226|~227|~228|~229|~230|~231|~232|~233|~234|~235|~236|~237|~238|~239|~240|~241|~242|~243|~244|~245|~246|~247|~248|~249|~250|~251|~252|~253|~254|~255";
            applyTilde = true;
            ecLevel = 0;
            encodingMode = EncodingModes.Binary;
            PDFCols =10;
            PDFRows = 0;
            truncate = false;
            if (cmbMode.SelectedIndex == 2) // BMP raster image output
            {
                raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3);
                File.WriteAllBytes("PDF417" + counter.ToString() + ".BMP", raster);


            }
            else if (cmbMode.SelectedIndex == 3)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, null, 2, 2);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".SVG", vector);
            }
            else if (cmbMode.SelectedIndex == 4)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, null, 2, 1);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".HTML", vector);
            }
            else
            {
                encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType);
            }
            renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector);

            if (chkSaveEPS.Checked)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecEPS, null, 2, 2);
                File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector);

            }
            counter++;

            //****************************************************************************************************************************************************
            dataToEncode = "[3000CHRS::THE FOLLOWING IS A 2-D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING THE FOLLOWING IS A 2DSCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 123456789883000CHRS-THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A2DScanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING THE FOLLOWING IS A 2DSCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 12345678988**]";
            applyTilde = true;
            ecLevel = 0;
            encodingMode = EncodingModes.Binary;
            PDFCols = 0;
            PDFRows = 0;
            truncate = false;
            if (cmbMode.SelectedIndex == 2) // BMP raster image output
            {
                raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3);
                File.WriteAllBytes("PDF417" + counter.ToString() + ".BMP", raster);


            }
            else if (cmbMode.SelectedIndex == 3)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, null, 2, 2);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".SVG", vector);
            }
            else if (cmbMode.SelectedIndex == 4)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, null, 2, 1);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".HTML", vector);
            }
            else
            {
                encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType);
            }
            renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector);

            if (chkSaveEPS.Checked)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecEPS, null, 2, 2);
                File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector);

            }
            counter++;


            //****************************************************************************************************************************************************
            dataToEncode = "[3000CHRS::THE FOLLOWING IS A 2-D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING THE FOLLOWING IS A 2DSCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 123456789883000CHRS-THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A2DScanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING THE FOLLOWING IS A 2DSCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 12345678988**]";
            applyTilde = true;
            ecLevel = 0;
            encodingMode = EncodingModes.Text;
            PDFCols = 0;
            PDFRows = 0;
            truncate = false;
            if (cmbMode.SelectedIndex == 2) // BMP raster image output
            {
                raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3);
                File.WriteAllBytes("PDF417" + counter.ToString() + ".BMP", raster);


            }
            else if (cmbMode.SelectedIndex == 3)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, null, 2, 2);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".SVG", vector);
            }
            else if (cmbMode.SelectedIndex == 4)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, null, 2, 1);
                //                File.WriteAllText("PDF417" + counter.ToString() + ".HTML", vector);
            }
            else
            {
                encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType);
            }
            renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector);

            if (chkSaveEPS.Checked)
            {
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecEPS, null, 2, 2);
                File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector);

            }
            counter++;
        }

        public void renderBarcodeToTab(string tabName, string dataToEncode,string encodingMode, string encodedText, byte[] raster = null, string vector = null)
        {

            int LL= 20;
            int LTOP = 10;
            int YSpacing = 10;

            TabPage tp = new TabPage(tabName); //set tab text
            tp.Font = new System.Drawing.Font("Consolas", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            tp.BackColor = System.Drawing.Color.White;
            tp.AutoScroll = true; //allow scrolling to fit output
            tabControl1.TabPages.Add(tp); //add tab to page

            //TOP - LEFT
            Label showDTEText = new Label();
            showDTEText.Name = "showDTEText";
            showDTEText.Location = new System.Drawing.Point(LL, LTOP);
            showDTEText.AutoSize = true;
            showDTEText.Text = "DATA ENCODED: ";
            showDTEText.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            tp.Controls.Add(showDTEText);

            Label showDTE = new Label();
            showDTE.Name = "showDTE";
            showDTE.Location = new System.Drawing.Point(LL, showDTEText.Location.Y + showDTEText.Height + YSpacing);
            showDTE.AutoSize = true;
            showDTE.Text = formatText(dataToEncode); 
            tp.Controls.Add(showDTE);


            //encodingMode
            Label lblEncMode = new Label();
            lblEncMode.Location = new System.Drawing.Point(LL, showDTE.Location.Y + showDTE.Height + YSpacing);
            lblEncMode.Name = "lblECM";
            lblEncMode.Size = new System.Drawing.Size(200, 13);
            lblEncMode.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            lblEncMode.Text = "ENC MODE: " + encodingMode.ToUpper();
            tp.Controls.Add(lblEncMode);

            //TOP - RIGHT

            //barcode
            Label lblBarcodeTitle = new Label();
            lblBarcodeTitle.AutoSize = true;
            lblBarcodeTitle.Location = new System.Drawing.Point(LL, lblEncMode.Location.Y + lblEncMode.Height + YSpacing);
            lblBarcodeTitle.Name = "lblDTETitle";
            //lblBarcodeTitle.Size = new System.Drawing.Size(83, 13);
            lblBarcodeTitle.Text = "BARCODE:";
            lblBarcodeTitle.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            tp.Controls.Add(lblBarcodeTitle);

            Label lblBarcode = new Label();
            lblBarcode.AutoSize = true;
            lblBarcode.Location = new System.Drawing.Point(LL, lblBarcodeTitle.Location.Y + lblBarcodeTitle.Height + YSpacing);
            lblBarcode.Name = "lblBarcodeBox";
            lblBarcode.Text = encodedText;

            if (cmbMode.SelectedIndex == 1)
            { 
                lblBarcode.Font = new System.Drawing.Font("Courier New", 6F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                tp.Controls.Add(lblBarcode);
            }
            else if(cmbMode.SelectedIndex == 0) {
                lblBarcode.Font = new System.Drawing.Font("IDAutomation2D", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                tp.Controls.Add(lblBarcode);

                //encoded data
                Label lblEncDataTitle = new Label();
                lblEncDataTitle.AutoSize = true;
                lblEncDataTitle.Location = new System.Drawing.Point(LL, lblBarcode.Location.Y + lblBarcode.Height + YSpacing);
                lblEncDataTitle.Name = "lblDTETitle";
                //lblEncDataTitle.Size = new System.Drawing.Size(83, 13);
                lblEncDataTitle.Text = "ENCODED RESULT:";
                lblEncDataTitle.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                tp.Controls.Add(lblEncDataTitle);

                Label lblEncData = new Label();
                lblEncData.Location = new System.Drawing.Point(LL, lblEncDataTitle.Location.Y + lblEncDataTitle.Height + YSpacing);
                lblEncData.Name = "lblEncData";
                lblEncData.AutoSize = true;
                lblEncData.Text = encodedText;
                tp.Controls.Add(lblEncData);

            }  else if (cmbMode.SelectedIndex == 2)
            {
                PictureBox picImage = new PictureBox();
                picImage.AutoSize = true;
                picImage.Location = new System.Drawing.Point(LL, lblBarcodeTitle.Location.Y + lblBarcodeTitle.Height + YSpacing);
                picImage.Name = "picCode";

                using (MemoryStream mStream = new MemoryStream(raster))
                {
                    Image img1 = Image.FromStream(mStream);
                    picImage.Image = img1;
                }
                tp.Controls.Add(picImage);

            } else if (cmbMode.SelectedIndex == 3 || cmbMode.SelectedIndex == 4)
            {
                WebBrowser webBrowser = new WebBrowser();
                webBrowser.Location = new System.Drawing.Point(LL, lblBarcodeTitle.Location.Y + lblBarcodeTitle.Height + YSpacing);
                webBrowser.Width = tp.Width - webBrowser.Left;
                webBrowser.Height  = tp.Height - webBrowser.Top;
                webBrowser.Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Bottom;
                webBrowser.DocumentText = vector;
                tp.Controls.Add(webBrowser);

            }


        }

        private string formatText(string inText)
        {
            int maxWidth = 175; //width of text shown in window
            string formattedString = "";

            for (int i = 0; i < inText.Length; i += maxWidth)
            {
                formattedString += SafeSubstring(inText, i, maxWidth) + Environment.NewLine;
            }

            return formattedString;
        }

        private string SafeSubstring(string value, int startIndex, int length)
        {
            return new string((value ?? string.Empty).Skip(startIndex).Take(length).ToArray());
        }

        private void chkSaveSVG_CheckedChanged(object sender, EventArgs e)
        {
            tabControl1.TabPages.Clear();
            inputTests();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
        }

        private void cmbMode_SelectedIndexChanged(object sender, EventArgs e)
        {
            tabControl1.TabPages.Clear();
            inputTests();
        }

        private void chkSaveEPS_CheckedChanged(object sender, EventArgs e)
        {
            tabControl1.TabPages.Clear();
            inputTests();
        }
    }
}
